public class Calculator5bVisitorImplementation implements Calculator5bVisitor {

 // helper method: visits all children of the current node
 public int[] visitChildren(Node n, Object data) {
  int numberChildren = n.jjtGetNumChildren();
  int[] value = new int[numberChildren];
  for(int i=0; i<numberChildren; i++)
  {
   value[i] = ((Integer)(n.jjtGetChild(i).jjtAccept(this, data))).intValue();
  }
  return value;
 }


 public Object visit(SimpleNode node, Object data) {
  System.out.println("Error: visit simple node:"+node);
  return null;
 }

 public Object visit(ASTAdd node, Object data) {
  int[] value = visitChildren(node,data);
  int result=0;
  for(int j=0;j<node.jjtGetNumChildren(); j++)
  {
   result+=value[j];
  }
  return result;
 }

 public Object visit(ASTSub node, Object data) {
  int[] value = visitChildren(node,data);
  int result=value[0];
  for(int j=1;j<node.jjtGetNumChildren(); j++)
  {
   result-=value[j];
  }
  return result;
 }

 public Object visit(ASTNeg node, Object data) {
  int[] value = visitChildren(node,data);
  return new Integer(-value[0]);
 }

 public Object visit(ASTIntLit node, Object data) {
  return new Integer(node.getValue());
 }
}
